/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.service.persistence;

import com.liferay.portal.service.persistence.BasePersistence;

import it.tref.liferay.mapit.map.model.PluginPortletPreferences;

/**
 * The persistence interface for the plugin portlet preferences service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author
 * @see PluginPortletPreferencesPersistenceImpl
 * @see PluginPortletPreferencesUtil
 * @generated
 */
public interface PluginPortletPreferencesPersistence extends BasePersistence<PluginPortletPreferences> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. Always use {@link PluginPortletPreferencesUtil} to access the plugin portlet preferences persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this interface.
	 */

	/**
	* Returns all the plugin portlet preferenceses where plugin = &#63;.
	*
	* @param plugin the plugin
	* @return the matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findByPlugin(
		java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns a range of all the plugin portlet preferenceses where plugin = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param plugin the plugin
	* @param start the lower bound of the range of plugin portlet preferenceses
	* @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	* @return the range of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findByPlugin(
		java.lang.String plugin, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns an ordered range of all the plugin portlet preferenceses where plugin = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param plugin the plugin
	* @param start the lower bound of the range of plugin portlet preferenceses
	* @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findByPlugin(
		java.lang.String plugin, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the first plugin portlet preferences in the ordered set where plugin = &#63;.
	*
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences findByPlugin_First(
		java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Returns the first plugin portlet preferences in the ordered set where plugin = &#63;.
	*
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchByPlugin_First(
		java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the last plugin portlet preferences in the ordered set where plugin = &#63;.
	*
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences findByPlugin_Last(
		java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Returns the last plugin portlet preferences in the ordered set where plugin = &#63;.
	*
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchByPlugin_Last(
		java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the plugin portlet preferenceses before and after the current plugin portlet preferences in the ordered set where plugin = &#63;.
	*
	* @param pluginPortletPreferencesId the primary key of the current plugin portlet preferences
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences[] findByPlugin_PrevAndNext(
		long pluginPortletPreferencesId, java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Removes all the plugin portlet preferenceses where plugin = &#63; from the database.
	*
	* @param plugin the plugin
	* @throws SystemException if a system exception occurred
	*/
	public void removeByPlugin(java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the number of plugin portlet preferenceses where plugin = &#63;.
	*
	* @param plugin the plugin
	* @return the number of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public int countByPlugin(java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns all the plugin portlet preferenceses where portletId = &#63; and plugin = &#63;.
	*
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @return the matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findByP_P(
		java.lang.String portletId, java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns a range of all the plugin portlet preferenceses where portletId = &#63; and plugin = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @param start the lower bound of the range of plugin portlet preferenceses
	* @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	* @return the range of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findByP_P(
		java.lang.String portletId, java.lang.String plugin, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns an ordered range of all the plugin portlet preferenceses where portletId = &#63; and plugin = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @param start the lower bound of the range of plugin portlet preferenceses
	* @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findByP_P(
		java.lang.String portletId, java.lang.String plugin, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the first plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	*
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences findByP_P_First(
		java.lang.String portletId, java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Returns the first plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	*
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchByP_P_First(
		java.lang.String portletId, java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the last plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	*
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences findByP_P_Last(
		java.lang.String portletId, java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Returns the last plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	*
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchByP_P_Last(
		java.lang.String portletId, java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the plugin portlet preferenceses before and after the current plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	*
	* @param pluginPortletPreferencesId the primary key of the current plugin portlet preferences
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences[] findByP_P_PrevAndNext(
		long pluginPortletPreferencesId, java.lang.String portletId,
		java.lang.String plugin,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Removes all the plugin portlet preferenceses where portletId = &#63; and plugin = &#63; from the database.
	*
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @throws SystemException if a system exception occurred
	*/
	public void removeByP_P(java.lang.String portletId, java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the number of plugin portlet preferenceses where portletId = &#63; and plugin = &#63;.
	*
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @return the number of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public int countByP_P(java.lang.String portletId, java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns all the plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	*
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @return the matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findByO_P_P(
		int ownerType, long plid, java.lang.String portletId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns a range of all the plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param start the lower bound of the range of plugin portlet preferenceses
	* @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	* @return the range of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findByO_P_P(
		int ownerType, long plid, java.lang.String portletId, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns an ordered range of all the plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param start the lower bound of the range of plugin portlet preferenceses
	* @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findByO_P_P(
		int ownerType, long plid, java.lang.String portletId, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the first plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	*
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences findByO_P_P_First(
		int ownerType, long plid, java.lang.String portletId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Returns the first plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	*
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchByO_P_P_First(
		int ownerType, long plid, java.lang.String portletId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the last plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	*
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences findByO_P_P_Last(
		int ownerType, long plid, java.lang.String portletId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Returns the last plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	*
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchByO_P_P_Last(
		int ownerType, long plid, java.lang.String portletId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the plugin portlet preferenceses before and after the current plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	*
	* @param pluginPortletPreferencesId the primary key of the current plugin portlet preferences
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences[] findByO_P_P_PrevAndNext(
		long pluginPortletPreferencesId, int ownerType, long plid,
		java.lang.String portletId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Removes all the plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63; from the database.
	*
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @throws SystemException if a system exception occurred
	*/
	public void removeByO_P_P(int ownerType, long plid,
		java.lang.String portletId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the number of plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	*
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @return the number of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public int countByO_P_P(int ownerType, long plid, java.lang.String portletId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the plugin portlet preferences where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63; or throws a {@link it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException} if it could not be found.
	*
	* @param ownerId the owner ID
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @return the matching plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences findByO_O_P_P_P(
		long ownerId, int ownerType, long plid, java.lang.String portletId,
		java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Returns the plugin portlet preferences where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
	*
	* @param ownerId the owner ID
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @return the matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchByO_O_P_P_P(
		long ownerId, int ownerType, long plid, java.lang.String portletId,
		java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the plugin portlet preferences where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
	*
	* @param ownerId the owner ID
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @param retrieveFromCache whether to use the finder cache
	* @return the matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchByO_O_P_P_P(
		long ownerId, int ownerType, long plid, java.lang.String portletId,
		java.lang.String plugin, boolean retrieveFromCache)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Removes the plugin portlet preferences where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63; from the database.
	*
	* @param ownerId the owner ID
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @return the plugin portlet preferences that was removed
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences removeByO_O_P_P_P(
		long ownerId, int ownerType, long plid, java.lang.String portletId,
		java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Returns the number of plugin portlet preferenceses where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63;.
	*
	* @param ownerId the owner ID
	* @param ownerType the owner type
	* @param plid the plid
	* @param portletId the portlet ID
	* @param plugin the plugin
	* @return the number of matching plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public int countByO_O_P_P_P(long ownerId, int ownerType, long plid,
		java.lang.String portletId, java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Caches the plugin portlet preferences in the entity cache if it is enabled.
	*
	* @param pluginPortletPreferences the plugin portlet preferences
	*/
	public void cacheResult(
		it.tref.liferay.mapit.map.model.PluginPortletPreferences pluginPortletPreferences);

	/**
	* Caches the plugin portlet preferenceses in the entity cache if it is enabled.
	*
	* @param pluginPortletPreferenceses the plugin portlet preferenceses
	*/
	public void cacheResult(
		java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> pluginPortletPreferenceses);

	/**
	* Creates a new plugin portlet preferences with the primary key. Does not add the plugin portlet preferences to the database.
	*
	* @param pluginPortletPreferencesId the primary key for the new plugin portlet preferences
	* @return the new plugin portlet preferences
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences create(
		long pluginPortletPreferencesId);

	/**
	* Removes the plugin portlet preferences with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param pluginPortletPreferencesId the primary key of the plugin portlet preferences
	* @return the plugin portlet preferences that was removed
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences remove(
		long pluginPortletPreferencesId)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	public it.tref.liferay.mapit.map.model.PluginPortletPreferences updateImpl(
		it.tref.liferay.mapit.map.model.PluginPortletPreferences pluginPortletPreferences)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the plugin portlet preferences with the primary key or throws a {@link it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException} if it could not be found.
	*
	* @param pluginPortletPreferencesId the primary key of the plugin portlet preferences
	* @return the plugin portlet preferences
	* @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences findByPrimaryKey(
		long pluginPortletPreferencesId)
		throws com.liferay.portal.kernel.exception.SystemException,
			it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;

	/**
	* Returns the plugin portlet preferences with the primary key or returns <code>null</code> if it could not be found.
	*
	* @param pluginPortletPreferencesId the primary key of the plugin portlet preferences
	* @return the plugin portlet preferences, or <code>null</code> if a plugin portlet preferences with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchByPrimaryKey(
		long pluginPortletPreferencesId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns all the plugin portlet preferenceses.
	*
	* @return the plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findAll()
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns a range of all the plugin portlet preferenceses.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of plugin portlet preferenceses
	* @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	* @return the range of plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findAll(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns an ordered range of all the plugin portlet preferenceses.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of plugin portlet preferenceses
	* @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> findAll(
		int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Removes all the plugin portlet preferenceses from the database.
	*
	* @throws SystemException if a system exception occurred
	*/
	public void removeAll()
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the number of plugin portlet preferenceses.
	*
	* @return the number of plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public int countAll()
		throws com.liferay.portal.kernel.exception.SystemException;
}