package it.tref.liferay.mapit.map.hook.listener;

import it.tref.liferay.mapit.map.model.PluginPortletPreferences;
import it.tref.liferay.mapit.map.service.PluginPortletPreferencesLocalServiceUtil;

import java.util.List;

import com.liferay.portal.ModelListenerException;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.model.BaseModelListener;
import com.liferay.portal.model.PortletPreferences;

public class PortletPreferencesListener extends BaseModelListener<PortletPreferences> {

  private final static Log _log = LogFactoryUtil.getLog(PortletPreferencesListener.class);

  @Override
  public void onAfterRemove(PortletPreferences model) throws ModelListenerException {

    try {
      List<PluginPortletPreferences> pluginsPortletPreferences =
          PluginPortletPreferencesLocalServiceUtil.getPortletPreferences(model.getOwnerType(), model.getPlid(),
              model.getPortletId(), QueryUtil.ALL_POS, QueryUtil.ALL_POS);
      for (PluginPortletPreferences pluginPortletPreferences : pluginsPortletPreferences) {
        PluginPortletPreferencesLocalServiceUtil.deletePluginPortletPreferences(pluginPortletPreferences);
      }
    } catch (SystemException e) {
      _log.error(e, e);
      throw new ModelListenerException(e);
    }
  }
}
